Module Declarations

  Public Enum Statut As Integer
    NonSoumis = 0
    Soumis = 1
    Approuve = 2
    Refuse = 3
  End Enum

  Public Const BTNVACANCES = 20
  Public Const BTNAPPROBATION = 25
  Public Const BTNLSTCONSULTATION = 22

  Public Const STATUT_PROJET_VALIDE = "PROJET"
  Public Const STATUT_CATEGORIE_VALIDE = "PROJET"
  Public Const RM_COL_PROJET = 1
  Public Const RM_COL_NOM_PROJET = 2
  Public Const RM_COL_CODE = 3
  Public Const RM_COL_BUDGET = 14
  Public Const RM_COL_DEPENSE = 15
  Public Const RM_COL_FONCTIONNEL = 16

  Public Const LUNDI = 3
  Public Const MARDI = 4
  Public Const MERCREDI = 5
  Public Const JEUDI = 6
  Public Const VENDREDI = 7
  Public Const SAMEDI = 1
  Public Const DIMANCHE = 2

  Public Const TOTAL_SEMAINE = 8
  Public Const TOTAL_CUMULE = 9
  Public Const TOTAL_PAYE = 10

  Public Const SRV_HANDEL = "HANDEL"
  Public Const SRV_STRAUSS = "STRAUSS"
  Public Const SRV_STRAUSSPAIE = "STRAUSSPAIE"

  Public TEMPSNORMAL = 0
  Public TEMPSCUMUL = 1
  Public TEMPSPAYE = 2
  Public COLOR_TEMPSCUMULE As System.Drawing.Color = Color.LightSalmon
  Public COLOR_TEMPSCUMULE_IMPRESSION As System.Drawing.Color = Color.Orange
  Public COLOR_TEMPSPAYE As System.Drawing.Color = Color.PowderBlue


  Public Const NOM_PROG = "Feuille de temps"
  'Public Const VERSION_PROG = "1.0.1"
  Public Const SRV_ID_Employe = "SRV_ID_Employe"
  Public EmployeCourant As New clsEmploye
  Public strVersion As String = System.Reflection.Assembly.GetExecutingAssembly.GetName.Version.Major.ToString & "." & System.Reflection.Assembly.GetExecutingAssembly.GetName.Version.Minor.ToString & "." & System.Reflection.Assembly.GetExecutingAssembly.GetName.Version.Build.ToString
  Public conoledb As New OleDb.OleDbConnection
  Public strHostName As String = System.Net.Dns.GetHostName()
  Public itemDrag As ListView.SelectedListViewItemCollection

  Public dtProjets As New DataTable 'La tables qui contient tous les projets
  Public dtTaches As New DataTable 'La table qui contient toutes les tches
  Public dtLstApprobation As New DataTable 'La table qui contient toutes les approbations

  Class MyItem
    'Since all we need is a "Text" property for this example we can
    'Subclass by inheriting any object desired.
    'For this example, we'll use the ListViewItem
    Inherits ListViewItem
    'each of the below public declarations will be "visible" to the outside
    'You may add as many of these declarations using whatever types you desire
    Public MyShowText As String
    Public MyID As Long
    'every value of MyInfo you want to store, get's added to the NEW declaration 
    Sub New(ByVal ShowText As String, ByVal lngid As Long)
      MyBase.New()
      'transfer all incoming parameters to your local storage
      MyShowText = ShowText
      MyID = lngid
      'and finally, pass back the Text property
      Me.Text = MyShowText
    End Sub
  End Class

  Public Class MenuFavoris
    Inherits MenuItem

    Private mlngIDProjet As Long
    Private mlngUIDTache As Long
    Private mstrNoProjet As String
    Private mstrNoTache As String
    Private mstrDescription As String

    Public Sub New()
      MyBase.New()
    End Sub

    Public Sub New(ByVal strText As String, ByVal ehEventHandler As System.EventHandler)
      MyBase.New(strText, ehEventHandler)
      mstrNoProjet = NoProjet
      mstrDescription = Description
    End Sub

    Public Property Titre() As String
      Get
        Return mstrNoProjet
      End Get
      Set(ByVal Value As String)
        mstrNoProjet = Value
      End Set
    End Property

    Public Property idProjet() As String
      Get
        Return mlngIDProjet
      End Get
      Set(ByVal Value As String)
        mlngIDProjet = Value
      End Set
    End Property

    Public Property NoProjet() As String
      Get
        Return mstrNoProjet
      End Get
      Set(ByVal Value As String)
        mstrNoProjet = Value
      End Set
    End Property

    Public Property NoTache() As String
      Get
        Return mstrNoTache
      End Get
      Set(ByVal Value As String)
        mstrNoTache = Value
      End Set
    End Property

    Public Property UIDTache() As String
      Get
        Return mlngUIDTache
      End Get
      Set(ByVal Value As String)
        mlngUIDTache = Value
      End Set
    End Property

    Public Property Description() As String
      Get
        Return mstrDescription
      End Get
      Set(ByVal Value As String)
        mstrDescription = Value
      End Set
    End Property

  End Class

  Public Function ConnecterBD(ByVal strServeur As String) As OleDb.OleDbConnection
    On Error GoTo ERR
    Dim cnn As New OleDb.OleDbConnection
    If UCase(strServeur) = "HANDEL" Then
      cnn.ConnectionString = "Provider=Microsoft.Jet.OLEDB.4.0;Data Source=" & System.AppDomain.CurrentDomain.BaseDirectory & "\bd1.mdb;User Id=admin;Password=;"
    End If

    cnn.Open()

    Return cnn
    Exit Function
ERR:

    Exit Function
  End Function

  'Retourne le projet utili par dfaut pour l'employ en cours
  Public Function RetourneProjetDefaut(ByVal lngID As Long, ByRef strNoProjet As String) As Long
    On Error GoTo ERR
    Dim stroledb As String
    Dim cnn As OleDb.OleDbConnection = ConnecterBD(SRV_HANDEL)
    Dim commoledb As New OleDb.OleDbCommand
    Dim dataReader As OleDb.OleDbDataReader
    'Dim strNoProjet As String
    Dim strNoProjetDefaut As String

    stroledb = "SELECT * From ProjetParDefaut WHERE idEmploye=" & lngID
    commoledb.Connection = cnn
    commoledb.CommandText = stroledb
    dataReader = commoledb.ExecuteReader

    If dataReader.Read() Then
      strNoProjet = dataReader("NoProjet").ToString
      Return dataReader("idProjetDefaut").ToString

    Else
      strNoProjet = "Non dfini"
      Return -1
    End If
    dataReader.Close()
    cnn.Close()
    Exit Function
ERR:
    MsgBox("Une erreur est survenue. Veuillez contacter le Service Informatique si l'erreur se reproduit." & vbNewLine & "Erreur: " & Err.Number & " " & Err.Description & vbNewLine & "Source: Declarations.RetourneProjetDefaut" & " Ligne: " & Err.Erl, MsgBoxStyle.Critical, "Erreur...")
  End Function

  Public Function JourDeLaSemaine(ByVal intJour As Int16) As Int16
    Select Case intJour
      Case 1 To 7
        Return 0
      Case 8 To 14
        Return 1
      Case 15 To 21
        Return 2
      Case 22 To 28
        Return 3
      Case 29 To 35
        Return 4
      Case 36 To 42
        Return 5
      Case 43 To 49
        Return 6
    End Select
  End Function

  Public Function LigneParJour(ByVal intJour As Int16) As Int16
    Select Case intJour
      Case 0
        Return 1
      Case 1
        Return 8
      Case 2
        Return 15
      Case 3
        Return 22
      Case 4
        Return 29
      Case 5
        Return 36
      Case 6
        Return 43
    End Select
  End Function



  '******************************************************
  ' Fonction qui extrait l'adresse de courriel d'une
  ' personne  partir de la chaine : NOM, Prnom (no)
  '******************************************************
  Public Function ExtraireCourriel(ByVal strEmpl As String) As String
    Dim strNom() As String
    Dim strPrenom() As String
    Dim strCourriel As String
    strNom = Split(strEmpl, ", ")
    strPrenom = Split(strNom(1), " (")

    strCourriel = strPrenom(0) & "." & strNom(0) & "@ino.ca"
    strCourriel = LCase(strCourriel)
    strCourriel = Replace(strCourriel, "", "e")
    strCourriel = Replace(strCourriel, "", "e")
    strCourriel = Replace(strCourriel, "", "e")
    strCourriel = Replace(strCourriel, "", "o")
    strCourriel = Replace(strCourriel, "", "a")
    strCourriel = Replace(strCourriel, "", "e")
    strCourriel = Replace(strCourriel, "", "e")
    strCourriel = Replace(strCourriel, "", "e")
    strCourriel = Replace(strCourriel, "", "e")
    strCourriel = Replace(strCourriel, "", "a")
    strCourriel = Replace(strCourriel, "", "c")
    strCourriel = Replace(strCourriel, "", "i")
    strCourriel = Replace(strCourriel, "", "i")
    strCourriel = Replace(strCourriel, "", "o")
    strCourriel = Replace(strCourriel, "", "u")
    strCourriel = Replace(strCourriel, "", "u")
    strCourriel = Replace(strCourriel, " ", ".")

    ExtraireCourriel = strCourriel
  End Function





  Public Function GetIcon(ByVal myBMP)
    Dim ico As Icon

    Dim bmIcon As Bitmap = CType(myBMP, Bitmap)

    ico = Icon.FromHandle(bmIcon.GetHicon)

    Return ico
  End Function



  Public Function VerifierVersion(ByVal strVersion As String) As Boolean
    On Error GoTo ERR
    Dim stroledb As String
    Dim cnn As OleDb.OleDbConnection = ConnecterBD(SRV_HANDEL)
    Dim commoledb As New OleDb.OleDbCommand
    Dim dataReader As OleDb.OleDbDataReader

    If cnn Is Nothing Then Exit Function
    stroledb = "SELECT * FROM VersionsSupportees WHERE Version = '" & strVersion & "'"
    commoledb.Connection = cnn
    commoledb.CommandText = stroledb
    dataReader = commoledb.ExecuteReader

    If dataReader.HasRows Then
      Return False
    Else
      Return True
    End If

    dataReader.Close()
    cnn.Close()
    Exit Function
ERR:
    MsgBox("Une erreur est survenue. Veuillez contacter le Service Informatique si l'erreur se reproduit." & vbNewLine & "Erreur: " & Err.Number & " " & Err.Description & vbNewLine & "Source: Declarations.VerifierVersion" & " Ligne: " & Err.Erl, MsgBoxStyle.Critical, "Erreur...")

  End Function
  '//////////////////
  Public Function ObtenirNomProjet(ByVal lngIDProjet As Long)
    On Error GoTo ERR
    Dim cnn As OleDb.OleDbConnection = ConnecterBD(SRV_HANDEL)
    Dim stroledb As String
    Dim commoledb As New OleDb.OleDbCommand
    Dim dataReader As OleDb.OleDbDataReader

    stroledb = "SELECT TitreProjet FROM ProjetsImport WHERE IDProjet = " & lngIDProjet
    commoledb.Connection = cnn
    commoledb.CommandText = stroledb
    dataReader = commoledb.ExecuteReader
    If dataReader.Read Then
      ObtenirNomProjet = dataReader("TitreProjet")
    Else
      ObtenirNomProjet = ""
    End If

    dataReader.Close()
    dataReader = Nothing
    cnn.Close()
    cnn = Nothing
    Exit Function
ERR:
    MsgBox("Une erreur est survenue. Veuillez contacter le Service Informatique si l'erreur se reproduit." & vbNewLine & "Erreur: " & Err.Number & " " & Err.Description & vbNewLine & "Source: Declarations.ObtenirNomProjet" & " Ligne: " & Err.Erl, MsgBoxStyle.Critical, "Erreur...")

  End Function

  'Vrifie si la tche courante existe dans les vacances
  Public Function isVacances(ByVal strTache As String, ByRef strDescriptionVacances As String) As Boolean
    On Error GoTo ERR
    Dim cnn As OleDb.OleDbConnection = ConnecterBD(SRV_HANDEL)
    Dim stroledb As String
    Dim commoledb As New OleDb.OleDbCommand
    Dim dataReader As OleDb.OleDbDataReader

    stroledb = "SELECT Description FROM ListeConges WHERE Tache = '" & strTache & "'"
    commoledb.Connection = cnn
    commoledb.CommandText = stroledb
    dataReader = commoledb.ExecuteReader
    If dataReader.Read Then
      strDescriptionVacances = dataReader("Description")
      Return True
    Else
      Return False
    End If

    dataReader.Close()
    dataReader = Nothing
    cnn.Close()
    cnn = Nothing
    Exit Function
ERR:
    MsgBox("Une erreur est survenue. Veuillez contacter le Service Informatique si l'erreur se reproduit." & vbNewLine & "Erreur: " & Err.Number & " " & Err.Description & vbNewLine & "Source: Declarations.isVacances" & " Ligne: " & Err.Erl, MsgBoxStyle.Critical, "Erreur...")

  End Function

  Public Function FeuilleExist(ByVal dteSemaine As Date) As Boolean
    On Error GoTo ERR
    Dim stroledb As String
    Dim cnn As OleDb.OleDbConnection = ConnecterBD(SRV_HANDEL)
    Dim commoledb As New OleDb.OleDbCommand
    Dim dataReader As OleDb.OleDbDataReader

    stroledb = "SELECT * FROM FeuillesTemps WHERE DateSemaine = '" & Format(dteSemaine, "yyyy-MM-dd") & "' AND idEmploye = " & EmployeCourant.IdEmp

    commoledb.Connection = cnn
    commoledb.CommandText = stroledb
    dataReader = commoledb.ExecuteReader

    If dataReader.HasRows Then
      Return True
    Else
      Return False
    End If

    dataReader.Close()
    cnn.Close()
    Exit Function
ERR:
    MsgBox("Une erreur est survenue. Veuillez contacter le Service Informatique si l'erreur se reproduit." & vbNewLine & "Erreur: " & Err.Number & " " & Err.Description & vbNewLine & "Source: Declarations.FeuilleExist" & " Ligne: " & Err.Erl, MsgBoxStyle.Critical, "Erreur...")
  End Function

  Public Function padQuote(ByVal strString As String) As String
    Return Replace(strString, "'", "''")
  End Function

  Public Function StatutProjet(ByVal lngIDProjet As Long) As String
    Dim strStatut As String = "ERREUR"
    Dim dvFiltre As New DataView(dtProjets)
    dvFiltre.RowFilter = String.Format("[IDProjet] = {0}", lngIDProjet)

    If dvFiltre.Count > 0 Then
      strStatut = Trim(dvFiltre(0)("STATUT"))
    End If
    dvFiltre = Nothing
    Return strStatut
  End Function

  Public Function StatutTache(ByVal strID As String) As Boolean
    Dim bolStatut As Boolean = False
    Dim dvFiltre As New DataView(dtTaches)
    dvFiltre.RowFilter = String.Format("[ID] = '{0}'", strID)

    If dvFiltre.Count > 0 Then
      bolStatut = dvFiltre(0)("STATUT")
    End If
    dvFiltre = Nothing
    Return bolStatut
  End Function

  Public Function UIDTache(ByVal strID As String) As Long
    Dim lngUID As Long = -1
    Dim dvFiltre As New DataView(dtTaches)
    dvFiltre.RowFilter = String.Format("[ID] = '{0}'", strID)

    If dvFiltre.Count > 0 Then
      lngUID = Trim(dvFiltre(0)("UIDTache"))
    End If
    dvFiltre = Nothing
    Return lngUID
  End Function
End Module